#!/bin/sh

. /var/log/copfilter/default/etc/global_settings
. /var/ipcop/main/settings
. /var/log/copfilter/default/langs/en.sh
. /var/log/copfilter/default/langs/${LANGUAGE}.sh


if [ "x${ICAP_UPDATE_PERIOD}" = "x" ]; then
    exit 0
fi

# set some values for calculating blacklist update time
MIN=`date +%M`
HOR=`date +%H`
EXACT=$(( ( $HOR * 60 ) + $MIN ))
REALM=0
REALM=$(( ( $EXACT / 5 ) * 5 ))
SMIN=0

SMIN=$(( ( ${ICAP_HOURS} * 60 ) + ${ICAP_MINUTES} ))
icap_updateperiod=0
icap_realtime=0

# calculate normal update intervall
if  [ "x${ICAP_UPDATE_PERIOD}" = "xdaily" ]; then
        icap_updateperiod=$(( ${ICAP_UPDATE_VALUE} * 1440 ))
elif  [ "x${ICAP_UPDATE_PERIOD}" = "xweekly" ]; then
        icap_updateperiod=$(( ${ICAP_UPDATE_VALUE} * 10080 ))
elif  [ "x${ICAP_UPDATE_PERIOD}" = "xmonthly" ]; then
        icap_updateperiod=$(( ${ICAP_UPDATE_VALUE} * 40320 ))
else
        icap_updateperiod=$(( ${ICAP_UPDATE_VALUE} * 1440 ))
fi

# Calculate first time to run blacklist update
if [ "x${ICAP_UPDATE_PERIOD}" = "xdaily" ]; then
    if [ $SMIN -le $REALM ]; then
        icap_realtime=$(( ( ( ( ${ICAP_UPDATE_VALUE} * 1440 ) - $REALM ) + $SMIN ) ))
    else
        if [ ${ICAP_UPDATE_VALUE} = 1 ]; then
            icap_realtime=$(( $SMIN - $REALM ))
        else
            icap_realtime=$(( ( ( $SMIN - $REALM ) + ( ${ICAP_UPDATE_VALUE} * 1440 ) ) ))
        fi
    fi

elif [ "x${ICAP_UPDATE_PERIOD}" = "xweekly" ]; then
        if [ $SMIN -le $REALM ]; then
            icap_realtime=$(( ( ( ( ${ICAP_UPDATE_VALUE} * 10080 ) - $REALM ) + $SMIN ) ))
        else
            icap_realtime=$(( ( ( $SMIN - $REALM ) + ( ${ICAP_UPDATE_VALUE} * 10080 ) ) ))
        fi

elif  [ "x${ICAP_UPDATE_PERIOD}" = "xmonthly" ]; then
        if [ $SMIN -le $REALM ]; then
            icap_realtime=$(( ( ( ( ${ICAP_UPDATE_VALUE} * 40320 ) - $REALM ) + $SMIN ) ))
        else
            icap_realtime=$(( ( ( $SMIN - $REALM ) + ( ${ICAP_UPDATE_VALUE} * 40320 ) ) ))
        fi

elif [ $SMIN -le $REALM ]; then
        icap_realtime=$(( ( ( ( ${ICAP_UPDATE_VALUE} * 1440 ) - $REALM ) + $SMIN ) ))
else
    if [ ${ICAP_UPDATE_VALUE} = 1 ]; then
        icap_realtime=$(( ( $SMIN - $REALM ) ))
    else
        icap_realtime=$(( ( ( $SMIN - $REALM ) + ( ${ICAP_UPDATE_VALUE} * 1440 ) ) ))
    fi
fi


icap_updateperiod=$(( $icap_updateperiod - 5 ))
icap_realtime=$(( $icap_realtime - 5 ))

if [ $icap_updateperiod -le 5 ]; then
     $icap_updateperiod=5
fi

echo $icap_updateperiod > ${BASEDIR}/etc/icap_counter.conf
chown nobody.nobody ${BASEDIR}/etc/icap_counter.conf

if [ "x${ICAP_UPDATE_METHOD}" = "xperiodically" ]; then

    # check, if we are up to date
    COUNTER=$(cat ${BASEDIR}/etc/icap_counter)

    if [ $COUNTER != $icap_updateperiod -o ${ICAP_UPDATE_VALUE} = 1 ]; then

        if [ "x${ICAP_UPDATE_PERIOD}" = "xdaily" ]; then
                echo $icap_realtime > ${BASEDIR}/etc/icap_counter
                chown nobody.nobody ${BASEDIR}/etc/icap_counter
        fi

    fi

fi


exit 0


